=begin
Select_next_component_v1.10
Copyright 2010, Atelier

Freely use, and abuse at your own risk. Fitness of use is 
not warranty implied.
 
Consecutively selects, and highlights each component, and 
group within the model. If an instance can not be seen, it is
nested.  Select X-ray to locate them. When the option to
locate unique instances is selected, the nested instances are 
skipped.
  
=end

def atelier_select_component_main_proc

	file_path_name=File.expand_path("sketchup.exe")
	puts File.dirname(file_path_name)
	
	model=Sketchup.active_model
	entities=model.entities
	selection=model.selection
	selection.clear
	model.close_active						#close any open model

	#save file name
#	file_name=model.path.split("\\")	#get PathFile name and place in array
#	n_count = -1
#	file_name.each do |ea| 				#count array
#		n_count=n_count+1
#	end
#	file_name = file_name[n_count]	#extract file name for later

	file_name=File.basename(model.path)

	if file_name==nil							#if file name nil, file name is temp.skp
		file_name="temp.skp"
	end

	if @hide_flag!=true					#initilize flag to hide (or not) unselected instances.
		@hide_flag=false
	end

	ci_string=""									#string of component instances, get ci_string from memory
	ci_string=Sketchup.read_default "honoluludesktop", "ci_array", file_name+"~None"
	@ci_array=ci_string.split("~")	#convert to array

	@unique=false							#initlize unique or all function
	@ci_unique=[]							#unique array of all unique instances
	unique_string=""							#initilize unique flag, then get flag status from memory
	unique_string=Sketchup.read_default "honoluludesktop", "ci_unique", "false"
	if unique_string=="false"			#recover flag to switch between all and unique instances
		@unique=false						#set global variable
	else
		@unique=true
	end
	if @ci_array[0]==file_name		#test filename is first data in array
		@ci_array.shift						#yes, get component instance
	else
		@ci_array[0]="None"				#no match, clear array
	end
	if @ci_array[0]=="None" 			#is array cleared, create new array of components
		@ci_all=[]								#initilize all component instance master array
		entities.each do |ent|					#search all entities for instances
			if ent.is_a? Sketchup::ComponentInstance or ent.is_a? Sketchup::Group
				if @unique==true			#is component or group, so test unique components flag set
					ci_found=false			#yes, so turn off component found flag
					@ci_unique.each do |e|				#here to check if current instance is already found
						if ent.is_a? Sketchup::ComponentInstance
							if e==ent.definition.name	#must be component so test matching name
								ci_found=true					#set found flag
							end
						else											#must be a group
							if e==ent.name						#test matching name
								ci_found=true
							end
						end
					end
					if ci_found==false						#test if match flag if not found
						@ci_all.push ent						#not foud so put on master array
						@ci_array.push ent					#save in current level array, then go to save in unique array
						if ent.is_a? Sketchup::ComponentInstance
							@ci_unique.push ent.definition.name
						else											#must be group
							@ci_unique.push ent.name
						end
					end
				else													#unique flag not set
					@ci_all.push ent							#just save instance on master array
					@ci_array.push ent						#and current array
				end
				if @hide_flag==false
					hdt_e_test(ent)								#call procedure to test for sub components
				end
			end
		end															#end of do loop, go back to test for next instance
		#at this point, no more instances, array of all components created
		ci_string=file_name+"~"+@ci_all.join("~")#make string of all arrays and save to memory
		result = Sketchup.write_default "honoluludesktop","ci_array",ci_string
		if @unique==false									#check unique flag and save status in memory
			result = Sketchup.write_default "honoluludesktop","ci_unique","false"
		else
			result = Sketchup.write_default "honoluludesktop","ci_unique","true"
		end
	end
	#come here to process master instance array
	if @ci_all==nil															#test for valid data base, or correct starting point
					hdt_clear_select_component						#if not go to beginning
	elsif (@ci_all[0].is_a? Sketchup::ComponentInstance or @ci_all[0].is_a? Sketchup::Group) 
		selection.add @ci_all[0]										#select component or group

		if @hide_flag==true
			hdt_hide_unselected(entities,selection)				#go here to hide unselected entities
		end

		Sketchup.send_action "selectSelectionTool:"			#set tool to selection before going out
		if @ci_all[0].is_a? Sketchup::ComponentInstance	#is it component? if so place instance name on bar
			Sketchup.set_status_text "Selected Component: [  #{@ci_all[0].definition.name}  ]",SB_PROMPT
		else																			#group name on bar
			Sketchup.set_status_text "Selected Group: [  #{@ci_all[0].name}  ]",SB_PROMPT
		end
		@ci_all.shift						#pop off first instance in the master array
	else											#not instance, must be done
		hdt_unhide_all(entities)
		result=Sketchup.write_default "honoluludesktop", "ci_array", file_name+("~")+"None"
		UI.messagebox "Done"
	end
	if @unique==false					#set condition of the unique or all flag
		result = Sketchup.write_default "honoluludesktop","ci_unique","false"
	else
		result = Sketchup.write_default "honoluludesktop","ci_unique","true"
	end
end

def hdt_e_test(ea)						#recursive procedure to find instances in instances
	if ea.is_a? Sketchup::ComponentInstance
		ent=ea.definition.entities		#get all entities in the component
	else											#must be group
		ent=ea.entities						#get all entities in group
	end
	ent.each do |e|							#check all new found entities
		if e.is_a? Sketchup::ComponentInstance or e.is_a? Sketchup::Group
			if @unique==true			#must be instance, is unique flag set?
				ci_found=false			#set not found flag to false (default)
				@ci_unique.each do |ea_ci|			#match current instance with unique list
					if e.is_a? Sketchup::ComponentInstance
						if ea_ci==e.definition.name#match componnent
							ci_found=true					#set flag if found
						end
					else											#must be a group
						if ea_ci==e.name					#match group
							ci_found=true					#set flag if found
						end
					end
				end
				if ci_found==false						#test if match instance found flag, else do not save
					@ci_all.push e						#must be not, save instance on master array
					@ci_array.push e					#save on current array, go on to save name on unique array
					if e.is_a? Sketchup::ComponentInstance
						@ci_unique.push e.definition.name
					else
						@ci_unique.push e.name
					end
				end
			else									#not unique, all
				@ci_all.push e			#save on master instance array
				@ci_array.push e		#save on current array
			end
			hdt_e_test(e)					#recursive test instance for more instances
		end
	end
end

def hdt_unhide_all(entities)
	entities.each do |ee|
		if ee.hidden?
			result=ee.visible=true
		end
	end
end

def hdt_hide_unselected(entities,selection)
	entities.each do |ee|
		if ee.visible?
			result=ee.hidden=true
		end
		selection.each do |es|
			if es.hidden? and es==ee
				result=ee.visible=true
			end
		end
	end
end

def hdt_switch_unique
	if @unique==true
		@unique=false
		Sketchup.set_status_text "Select All Instances",SB_PROMPT
		result = Sketchup.write_default "honoluludesktop","ci_unique","false"
	else
		@unique=true
		Sketchup.set_status_text "Select Unique Instances",SB_PROMPT
		result = Sketchup.write_default "honoluludesktop","ci_unique","true"
	end
	result=Sketchup.write_default "honoluludesktop", "ci_array", "None~None"
end

def hdt_clear_select_component
	result=Sketchup.write_default "honoluludesktop", "ci_array", "None~None"
	atelier_select_component_main_proc
end

def hdt_next_and_hide
	@hide_flag=true
	atelier_select_component_main_proc
end

def hdt_next_all
	if @hide_flag=true
		@hide_flag=false
		entities=Sketchup.active_model.entities
		hdt_unhide_all(entities)
	end
	atelier_select_component_main_proc
end

def hdt_xray_switch
	if Sketchup.active_model.rendering_options["ModelTransparency"]
		Sketchup.active_model.rendering_options["ModelTransparency"] = false
	else
		Sketchup.active_model.rendering_options["ModelTransparency"] = true
	end
end

unless file_loaded? File::basename(__FILE__)

	file_path_name=Sketchup.find_support_file "sketchup.exe", "" 
	file_path_name=File.dirname(file_path_name)+"/Plugins/hdt_folder/"

	select_tb = UI::Toolbar.new("Select Components") 
	cmd2 = UI::Command.new("Select First Component") { hdt_clear_select_component } 
	cmd2.small_icon = file_path_name+"button_first_16.png" 
	cmd2.large_icon = file_path_name+"button_first_24.png"
	cmd2.tooltip = "First Instance" 
	select_tb.add_item(cmd2) 
	
	cmd1 = UI::Command.new("Select Next Component") { hdt_next_all } 
	cmd1.small_icon = file_path_name+"button_next_16.png" 
	cmd1.large_icon = file_path_name+"button_next_24.png"
	cmd1.tooltip = "Next Instance" 
	select_tb.add_item(cmd1) 
	
	cmd5 = UI::Command.new("Select Next Component") { hdt_next_and_hide } 
	cmd5.small_icon = file_path_name+"button_hide_16.png" 
	cmd5.large_icon = file_path_name+"button_hide_24.png"
	cmd5.tooltip = "Next Unnested Instance, Hide Rest" 
	select_tb.add_item(cmd5) 
	
	cmd4 = UI::Command.new("X-ray: On | Off") { hdt_xray_switch } 
	cmd4.small_icon = file_path_name+"button_xray_16.png" 
	cmd4.large_icon = file_path_name+"button_xray_24.png"
	cmd4.tooltip = "X-ray: On | Off" 
	select_tb.add_item(cmd4) 
	
	cmd3 = UI::Command.new("Instances: Unique | All") { hdt_switch_unique } 
	cmd3.small_icon = file_path_name+"button_repeat_16.png" 
	cmd3.large_icon = file_path_name+"button_repeat_24.png"
	cmd3.tooltip = "Instances: Unique | All" 
	select_tb.add_item(cmd3) 

  	add_separator_to_menu("File")	
	UI.menu("File").add_item("Select Next Component") { atelier_select_component_main_proc }
	UI.menu("File").add_item("Select First Component") { hdt_clear_select_component }
    file_loaded File::basename(__FILE__)
end
